# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, popuplib, os
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func    = es.import_addon('sam/functions')
core    = es.import_addon('sam/core')
admins  = es.import_addon('sam/core/admins')
monitor = es.import_addon('sam/core/monitor')

# x # VARIABLES/DICTIONARIES/LISTS # xx #
nosounds = 'No sounds found in the folders.'
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# ADD MAIN PAGE OPTION
	monitor.addons.append('adminsounds')

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# REMOVE MAIN PAGE OPTION
	monitor.addons.remove('adminsounds')

	# POPUPS
	func.popupDelete('sounds')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID, PAGE=False):
	if admins.can(ID, 'Admin Sounds'):
		sounds = getSounds()
		if len(list(sounds)) > 0:
			func.popupDelete('sounds')
			popup = func.easymenu(popuplib.easymenu('sounds', None , play),'home')
			popup.settitle(func.header(func.langAddon('adminsounds','TITLE')))
			for item in sounds: popup.addoption(sounds[item], item)
			if PAGE and PAGE in sounds: popup.sendPage(func.sendPage(ID,sounds.index(PAGE)))
			else: popup.send(ID)
		else:
			func.hudhint(ID,nosounds,'ADMIN SOUNDS')
			func.log(nosounds,'ADMIN SOUNDS')
			core.home(ID)
	else: core.home(ID)

# ------------------------------------------------------------------------------- #
def play(ID, SOUND, POPUP):
	func.playall(SOUND)
	page(ID, SOUND)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def getSounds():
	sounds = {}
	for path, dirs, files in os.walk(func.soundsPath):
		for sound in files:
			if sound.endswith(('.mp3','.wav')): sounds[sound.replace('.mp3','').replace('.wav','')] = path.replace('cstrike/sound/','') + '/' + sound
	return sounds

# =============================================================================== #