# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es
import popuplib
import playerlib
import os
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func    = es.import_addon('sam/functions')
core    = es.import_addon('sam/core')
monitor = es.import_addon('sam/core/monitor')
admins  = es.import_addon('sam/core/admins')

# x # VARIABLES/DICTIONARIES/LISTS # xx #
cmds       = ('add_ct','add_t','kick')
toggle     = ('auto_follow','randombuy','join_after_player','defer_to_human')
dif        = {0:'easy',1:'normal',2:'hard',3:'expert'}
quota      = es.ServerVar('bot_quota')
quotamode  = es.ServerVar('bot_quota_mode')
difficulty = es.ServerVar('bot_difficulty')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# ADD MAIN PAGE OPTION
	monitor.addons.append('bots')

	# POPUPS
	func.popupDelete('botsManager')
	func.popupDelete('botsSettings')

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# REMOVE MAIN PAGE OPTION
	monitor.addons.remove('bots')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID, SEND=True):
	if admins.can(ID, 'Bots Manager'):
		core.home(ID, False)
		func.popupDelete('botsManager')
		popup = func.easymenu(popuplib.easymenu('botsManager', None, managerChoice),'home')
		popup.settitle(func.header(func.langAddon('bots','TITLE')))
		for x in cmds: popup.addoption(x, func.langAddon('bots',x.upper()))
		popup.addoption('quota', func.langAddon('bots','QUOTA',{'quota':es.ServerVar('bot_quota')}))
		popup.addoption('set', func.langAddon('bots','SETTINGS',))
		if SEND: popup.send(ID)
	else: core.home(ID)

# ------------------------------------------------------------------------------- #
def managerChoice(ID, OPTION, POPUP):
	if OPTION in cmds: es.server.insertcmd('bot_%s' % OPTION)
	elif OPTION == 'quota':
		if int(quota) < 32: quota.set(int(quota) + 1)
		else: quota.set(0)
	elif OPTION == 'set':
		func.popupDelete('botsSettings')
		popup = func.easymenu(popuplib.easymenu('botsSettings', None, settingsChoice),'botsManager')
		popup.settitle(func.header(func.langAddon('bots','SETTINGS')))
		popup.addoption('dif', func.langAddon('bots','DIFFICULTY',{'dif':dif[int(difficulty)].upper()}))
		popup.addoption('quotamode', func.langAddon('bots','QUOTA_MODE',{'mode':str(quotamode).upper()}))
		for x in toggle:
			var = es.ServerVar('bot_'+x)
			if int(var) == 1: popup.addoption(x, func.langAddon('bots',x.upper(),{'value':func.langCommon('YES')}))
			else: popup.addoption(x, func.langAddon('bots',x.upper(),{'value':func.langCommon('NO')}))
		popup.send(ID)
	if OPTION != 'set': page(ID)

# ------------------------------------------------------------------------------- #
def settingsChoice(ID, OPTION, POPUP):
	if OPTION == 'dif':
		if int(difficulty) < 3: difficulty.set(int(difficulty)+1)
		else: difficulty.set(0)
	elif OPTION == 'quotamode':
		if quotamode == 'normal': quotamode.set('fill')
		elif quotamode == 'fill': quotamode.set('match')
		elif quotamode == 'match': quotamode.set('normal')
	elif OPTION in toggle:
		var = es.ServerVar('bot_'+OPTION)
		if int(var) > 0: var.set(0)
		else: var.set(1)
	managerChoice(ID, 'set', None)

# =============================================================================== #