# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es
import playerlib
import cmdlib
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func     = es.import_addon('sam/functions')
pcontrol = es.import_addon('sam/core/pcontrol')
monitor  = es.import_addon('sam/core/monitor')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
temp = {'amount':16000}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CMD
	cmdlib.registerServerCommand('sam_round_money', rmCMD, 'SAM')

	# CFG
	lib = {'sam_round_money':{'value':temp['amount'],'description':'The amount of money to give to all players at the beggining of each round.'},
		   'addon':monitor.get('roundmoney','name')}
	monitor.cfg('roundmoney', lib)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMD
	cmdlib.unregisterServerCommand('sam_round_money')

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def rmCMD(args):
	if args:
		try:
			args = int(''.join(args))
			if args in range(0,16001): temp['amount'] = args
		except: pass

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def round_start(ev):
	for team in ('#t','#ct'):
		for x in playerlib.getPlayerList(team): x.setCash(temp['amount'])

# =============================================================================== #