# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
from __future__ import with_statement
import es
import cmdlib
import os
import popuplib
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func = es.import_addon('sam/functions')

# x # VARIABLES/DICTIONARIES/LISTS # xx #
file = 'cstrike/cfg/sam_config/rules.txt'
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CMD
	cmdlib.registerSayCommand('!rules', rulesCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_rules', rulesCMD, 'SAM CMD')

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMD
	cmdlib.unregisterSayCommand('!rules')
	cmdlib.unregisterSayCommand('!sam_rules')

	# DELETE POPUPS
	func.popupDelete('rules')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def rulesCMD(ID, ARGS):
	func.popupDelete('rules')
	popup = func.easymenu(popuplib.easymenu('rules', None , rulesChoice))
	popup.settitle(func.header('Server Rules'))
	if len(getRules()) > 0:
		for item in getRules(): popup.addoption(item, item)
		popup.send(ID)
	else: func.hudhint(ID, 'SAM havent found any Rules.', func.errortag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def rulesChoice(ID, choice, popup): func.popupDelete('rules')

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def getRules():
	if not os.path.isfile(file): createFile()
	with open(file) as f: return [line for line in f.readlines() if not line.startswith('#') and not line.startswith(' ')]

# =============================================================================== #
# === <<<> FILTERS AND OTHERS <>>> ============================================== #
# =============================================================================== #
def createFile():
	if not os.path.isfile(file):
		f = open(file,'w')
		f.write('# - - - - - - - - - - - - - - - - - #\n')
		f.write('#  Source Admin Menu # Rules file   #\n')
		f.write('# - - - - - - - - - - - - - - - - - #\n')
		f.write('#\n')
		f.write('#  How to add rules?\n')
		f.write('#  Start the line with a - and the rule next to it.\n')
		f.write('#\n')
		f.write('#  Server rules are accessable in-game typing !rules.\n')
		f.write('# \n')
		f.write('# - - - - - - - - - - - - - - - - - -\n \n')
		f.write('Respect both Admins and Players.\n')
		f.write('Do not spam the chat or mic.\n')
		f.write('Cheat is totaly forbidden.\n')
		f.write('Add the server to favourites.\n')
		f.write('Have fun.\n')
		f.close()

# =============================================================================== #