# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es
import playerlib
import cmdlib
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func    = es.import_addon('sam/functions')
monitor = es.import_addon('sam/core/monitor')

# x # VARIABLES/DICTIONARIES/LISTS # xx #
temp = {'trigger':15,'current':0}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CMD
	cmdlib.registerServerCommand('sam_switcher_rounds', triggerCMD, 'SAM')

	# CFG
	lib = {'sam_switcher_rounds':{'value':temp['trigger'],'description':'Number of rounds to before switching teams.'},
		   'addon':monitor.get('switcher','name')}
	monitor.cfg('switcher', lib)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMD
	cmdlib.unregisterServerCommand('sam_switcher_rounds')

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def switch():
	if (1+temp['current']) >= temp['trigger']:
		teams = es.import_addon('sam/core/pcontrol/manageteams')
		teams.switchTeams(False, None, None)
		temp['current'] = 0
	else:
		temp['current'] += 1
		num = temp['trigger']-temp['current']
		if num == 1: num = 'next'
		func.log('Swicthing teams in %s round/s.' % (num),'Switcher')

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def triggerCMD(args):
	if args:
		args = ' '.join(args)
		if args.isdigit(): temp['trigger'] = int(args)

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def round_end(ev): switch()

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def es_map_start(ev): temp['current'] = 0

# =============================================================================== #