# =============================================================================== #
#
#	WARNING NOTES:
#
#	* Do not change this file, or any other subfiles from this script if you don't no what you are doing.
#	* Before changing this script, please, read the document 'MESSAGE TO DEVELOPERS' that comes with the script files.
#	* Coping this script, or its code, will result in a report to the EventScripts moderators.
#	* This script was written with Sublime Text 3, where this code style suits best.
#
#	Coded by: SkinN.
#
# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxxx # SAM INFO # xxxxxxxxxxxx #
script = es.AddonInfo()
script.name        = 'SAM ( Source Admin Menu )'
script.version     = '4.0.full'
script.basename    = 'sam'
script.description = 'Complex server Admin Menu, with server modifications.'
script.author      = 'SkinN'
script.url         = 'http://addons.eventscripts.com/addons/view/sam'
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxx FUNCTIONS AND CORE MODULES LOAD x #
es.load('sam/functions')
es.load('sam/core')

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func = es.import_addon('sam/functions')

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	if script.version.endswith('dev'): func.dev = True

	### SCRIPT VERSION
	es.setinfo(func.version, script.version)
	es.makepublic(func.version)

	### TRIGGER UPDATE SYSTEM
	func.update(True)

	func.tell('#all', func.langCore('LOAD'), '#purple' + script.version)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	### UNLOADS
	es.unload('sam/core')
	es.unload('sam/functions')

	func.tell('#all', func.langCore('UNLOAD'), '#purple' + script.version)